## EDU.oswego.cs.dl.util.concurrent
Class CopyOnWriteArrayList

    java.lang.Object
      EDU.oswego.cs.dl.util.concurrent.CopyOnWriteArrayList

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, java.lang.Iterable, java.util.Collection, java.util.List

    public class CopyOnWriteArrayList

extends java.lang.Object
implements java.util.List, java.lang.Cloneable, java.io.Serializable

This class implements a variant of java.util.ArrayList in which all mutative operations (add, set, and so on) are implemented by making a fresh copy of the underlying array.

This is ordinarily too costly, but it becomes attractive when traversal operations vastly overwhelm mutations, and, especially, when you cannot or don't want to synchronize traversals, yet need to preclude interference among concurrent threads. The iterator method uses a reference to the state of the array at the point that the iterator was created. This array never changes during the lifetime of the iterator, so interference is impossible. (The iterator will not traverse elements added or changed since the iterator was created, but usually this is a desirable feature.)

As much code and documentation as possible was shamelessly copied from java.util.ArrayList (Thanks, Josh!), with the intent of preserving all semantics of ArrayList except for the copy-on-write property. (The java.util collection code could not be subclassed here since all of the existing collection classes assume elementwise mutability.)

Because of the copy-on-write policy, some one-by-one mutative operations in the java.util.Arrays and java.util.Collections classes are so time/space intensive as to never be worth calling (except perhaps as benchmarks for garbage collectors :-).

Three methods are supported in addition to those described in List and ArrayList. The addIfAbsent and addAllAbsent methods provide Set semantics for add, and are used in CopyOnWriteArraySet. However, they can also be used directly from this List version. The copyIn method (and a constructor that invokes it) allow you to copy in an initial array to use. This method can be useful when you first want to perform many operations on a plain array, and then make a copy available for use through the collection API.

Due to their strict read-only nature, element-changing operations on iterators (remove, set, and add) are not supported. These are the only methods throwing UnsupportedOperationException.

[ Introduction to this package. ]

See Also:
  `CopyOnWriteArraySet`, Serialized Form

Nested Class Summary
`protected static class` `CopyOnWriteArrayList.COWIterator`
`protected static class` `CopyOnWriteArrayList.COWSubList`

Field Summary
`protected java.lang.Object[]` `array_` The held array.

Constructor Summary
`CopyOnWriteArrayList()` Constructs an empty list
`CopyOnWriteArrayList(java.util.Collection c)` Constructs an list containing the elements of the specified Collection, in the order they are returned by the Collection's iterator.
`CopyOnWriteArrayList(java.lang.Object[] toCopyIn)` Create a new CopyOnWriteArrayList holding a copy of given array

Method Summary
`void` `add(int index, java.lang.Object element)` Inserts the specified element at the specified position in this list.
`boolean` `add(java.lang.Object element)` Appends the specified element to the end of this list.
`boolean` `addAll(java.util.Collection c)` Appends all of the elements in the specified Collection to the end of this list, in the order that they are returned by the specified Collection's Iterator.
`boolean` `addAll(int index, java.util.Collection c)` Inserts all of the elements in the specified Collection into this list, starting at the specified position.
`int` `addAllAbsent(java.util.Collection c)` Appends all of the elements in the specified Collection that are not already contained in this list, to the end of this list, in the order that they are returned by the specified Collection's Iterator.
`boolean` `addIfAbsent(java.lang.Object element)` Append the element if not present.
`protected java.lang.Object[]` `array()` Accessor to the array intended to be called from within unsynchronized read-only methods
`void` `clear()` Removes all of the elements from this list.
`java.lang.Object` `clone()` Returns a shallow copy of this list.
`boolean` `contains(java.lang.Object elem)` Returns true if this list contains the specified element.
`boolean` `containsAll(java.util.Collection c)` Returns true if this Collection contains all of the elements in the specified Collection.
`void` `copyIn(java.lang.Object[] toCopyIn, int first, int n)` Replace the held array with a copy of the `n` elements of the provided array, starting at position `first`.
`boolean` `equals(java.lang.Object o)` Compares the specified Object with this List for equality.
`java.lang.Object` `get(int index)` Returns the element at the specified position in this list.
`int` `hashCode()` Returns the hash code value for this List.
`int` `indexOf(java.lang.Object elem)` Searches for the first occurence of the given argument, testing for equality using the `equals` method.
`int` `indexOf(java.lang.Object elem, int index)` Searches for the first occurence of the given argument, beginning the search at `index`, and testing for equality using the `equals` method.
`protected static int` `indexOf(java.lang.Object elem, java.lang.Object[] elementData, int len)` static version allows repeated call without needed to grab lock for array each time
`boolean` `isEmpty()` Tests if this list has no components.
`java.util.Iterator` `iterator()` Returns an Iterator over the elements contained in this collection.
`int` `lastIndexOf(java.lang.Object elem)` Returns the index of the last occurrence of the specified object in this list.
`int` `lastIndexOf(java.lang.Object elem, int index)` Searches backwards for the specified object, starting from the specified index, and returns an index to it.
`protected static int` `lastIndexOf(java.lang.Object elem, java.lang.Object[] elementData, int len)`
`java.util.ListIterator` `listIterator()` Returns an Iterator of the elements in this List (in proper sequence).
`java.util.ListIterator` `listIterator(int index)` Returns a ListIterator of the elements in this List (in proper sequence), starting at the specified position in the List.
`protected void` `rangeCheck(int index, int length)` Check if the given index is in range.
`java.lang.Object` `remove(int index)` Removes the element at the specified position in this list.
`boolean` `remove(java.lang.Object element)` Removes a single instance of the specified element from this Collection, if it is present (optional operation).
`boolean` `removeAll(java.util.Collection c)` Removes from this Collection all of its elements that are contained in the specified Collection.
`void` `removeRange(int fromIndex, int toIndex)` Removes from this List all of the elements whose index is between fromIndex, inclusive and toIndex, exclusive.
`boolean` `retainAll(java.util.Collection c)` Retains only the elements in this Collection that are contained in the specified Collection (optional operation).
`java.lang.Object` `set(int index, java.lang.Object element)` Replaces the element at the specified position in this list with the specified element.
`int` `size()` Returns the number of components in this list.
`java.util.List` `subList(int fromIndex, int toIndex)` Returns a view of the portion of this List between fromIndex, inclusive, and toIndex, exclusive.
`java.lang.Object[]` `toArray()` Returns an array containing all of the elements in this list in the correct order.
`java.lang.Object[]` `toArray(java.lang.Object[] a)` Returns an array containing all of the elements in this list in the correct order.
`java.lang.String` `toString()` Returns a string representation of this Collection, containing the String representation of each element.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.List
`addAll, addAll, containsAll, removeAll, retainAll, toArray`

Field Detail

### array_

    protected transient java.lang.Object[] array_

  The held array. Directly access only within synchronized methods

Constructor Detail

### CopyOnWriteArrayList

    public CopyOnWriteArrayList()

  Constructs an empty list

### CopyOnWriteArrayList

    public CopyOnWriteArrayList(java.util.Collection c)

  Constructs an list containing the elements of the specified Collection, in the order they are returned by the Collection's iterator.

### CopyOnWriteArrayList

    public CopyOnWriteArrayList(java.lang.Object[] toCopyIn)

  Create a new CopyOnWriteArrayList holding a copy of given array

  Parameters:
    `toCopyIn` - the array. A copy of this array is used as the internal array.

Method Detail

### array

    protected java.lang.Object[] array()

  Accessor to the array intended to be called from within unsynchronized read-only methods

### copyIn

    public void copyIn(java.lang.Object[] toCopyIn,
                       int first,
                       int n)

  Replace the held array with a copy of the `n` elements of the provided array, starting at position `first`. To copy an entire array, call with arguments (array, 0, array.length).

  Parameters:
    `toCopyIn` - the array. A copy of the indicated elements of this array is used as the internal array.
    `first` - The index of first position of the array to start copying from.
    `n` - the number of elements to copy. This will be the new size of the list.

### size

    public int size()

  Returns the number of components in this list.

  Specified by:
    `size` in interface `java.util.Collection`
  Specified by:
    `size` in interface `java.util.List`
  Returns:
    the number of components in this list.

### isEmpty

    public boolean isEmpty()

  Tests if this list has no components.

  Specified by:
    `isEmpty` in interface `java.util.Collection`
  Specified by:
    `isEmpty` in interface `java.util.List`
  Returns:
    `true` if this list has no components; `false` otherwise.

### contains

    public boolean contains(java.lang.Object elem)

  Returns true if this list contains the specified element.

  Specified by:
    `contains` in interface `java.util.Collection`
  Specified by:
    `contains` in interface `java.util.List`
  Parameters:
    `o` - element whose presence in this List is to be tested.

### indexOf

    public int indexOf(java.lang.Object elem)

  Searches for the first occurence of the given argument, testing for equality using the `equals` method.

  Specified by:
    `indexOf` in interface `java.util.List`
  Parameters:
    `elem` - an object.
  Returns:
    the index of the first occurrence of the argument in this list; returns `-1` if the object is not found.
  See Also:
    `Object.equals(Object)`

### indexOf

    protected static int indexOf(java.lang.Object elem,
                                 java.lang.Object[] elementData,
                                 int len)

  static version allows repeated call without needed to grab lock for array each time

### indexOf

    public int indexOf(java.lang.Object elem,
                       int index)

  Searches for the first occurence of the given argument, beginning the search at `index`, and testing for equality using the `equals` method.

  Parameters:
    `elem` - an object.
    `index` - the index to start searching from.
  Returns:
    the index of the first occurrence of the object argument in this List at position `index` or later in the List; returns `-1` if the object is not found.
  See Also:
    `Object.equals(Object)`

### lastIndexOf

    public int lastIndexOf(java.lang.Object elem)

  Returns the index of the last occurrence of the specified object in this list.

  Specified by:
    `lastIndexOf` in interface `java.util.List`
  Parameters:
    `elem` - the desired component.
  Returns:
    the index of the last occurrence of the specified object in this list; returns -1 if the object is not found.

### lastIndexOf

    protected static int lastIndexOf(java.lang.Object elem,
                                     java.lang.Object[] elementData,
                                     int len)

### lastIndexOf

    public int lastIndexOf(java.lang.Object elem,
                           int index)

  Searches backwards for the specified object, starting from the specified index, and returns an index to it.

  Parameters:
    `elem` - the desired component.
    `index` - the index to start searching from.
  Returns:
    the index of the last occurrence of the specified object in this List at position less than index in the List; -1 if the object is not found.

### clone

    public java.lang.Object clone()

  Returns a shallow copy of this list. (The elements themselves are not copied.)

  Overrides:
    `clone` in class `java.lang.Object`
  Returns:
    a clone of this list.

### toArray

    public java.lang.Object[] toArray()

  Returns an array containing all of the elements in this list in the correct order.

  Specified by:
    `toArray` in interface `java.util.Collection`
  Specified by:
    `toArray` in interface `java.util.List`

### toArray

    public java.lang.Object[] toArray(java.lang.Object[] a)

  Returns an array containing all of the elements in this list in the correct order. The runtime type of the returned array is that of the specified array. If the list fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this list.

  If the list fits in the specified array with room to spare (i.e., the array has more elements than the list), the element in the array immediately following the end of the collection is set to null. This is useful in determining the length of the list only if the caller knows that the list does not contain any null elements.

  Parameters:
    `a` - the array into which the elements of the list are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
  Returns:
    an array containing the elements of the list.
  Throws:
    `java.lang.ArrayStoreException` - the runtime type of a is not a supertype of the runtime type of every element in this list.

### get

    public java.lang.Object get(int index)

  Returns the element at the specified position in this list.

  Specified by:
    `get` in interface `java.util.List`
  Parameters:
    `index` - index of element to return.
  Throws:
    `java.lang.IndexOutOfBoundsException` - index is out of range (index < 0 || index >= size()).

### set

    public java.lang.Object set(int index,
                                java.lang.Object element)

  Replaces the element at the specified position in this list with the specified element.

  Specified by:
    `set` in interface `java.util.List`
  Parameters:
    `index` - index of element to replace.
    `element` - element to be stored at the specified position.
  Returns:
    the element previously at the specified position.
  Throws:
    `java.lang.IndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).

### add

    public boolean add(java.lang.Object element)

  Appends the specified element to the end of this list.

  Specified by:
    `add` in interface `java.util.Collection`
  Specified by:
    `add` in interface `java.util.List`
  Parameters:
    `element` - element to be appended to this list.
  Returns:
    true (as per the general contract of Collection.add).

### add

    public void add(int index,
                    java.lang.Object element)

  Inserts the specified element at the specified position in this list. Shifts the element currently at that position (if any) and any subsequent elements to the right (adds one to their indices).

  Specified by:
    `add` in interface `java.util.List`
  Parameters:
    `index` - index at which the specified element is to be inserted.
    `element` - element to be inserted.
  Throws:
    `java.lang.IndexOutOfBoundsException` - index is out of range (index < 0 || index > size()).

### remove

    public java.lang.Object remove(int index)

  Removes the element at the specified position in this list. Shifts any subsequent elements to the left (subtracts one from their indices). Returns the element that was removed from the list.

  Specified by:
    `remove` in interface `java.util.List`
  Parameters:
    `index` - the index of the element to removed.
  Throws:
    `java.lang.IndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).

### remove

    public boolean remove(java.lang.Object element)

  Removes a single instance of the specified element from this Collection, if it is present (optional operation). More formally, removes an element `e` such that `(o==null ? e==null : o.equals(e))`, if the Collection contains one or more such elements. Returns true if the Collection contained the specified element (or equivalently, if the Collection changed as a result of the call).

  Specified by:
    `remove` in interface `java.util.Collection`
  Specified by:
    `remove` in interface `java.util.List`
  Parameters:
    `element` - element to be removed from this Collection, if present.
  Returns:
    true if the Collection changed as a result of the call.

### removeRange

    public void removeRange(int fromIndex,
                            int toIndex)

  Removes from this List all of the elements whose index is between fromIndex, inclusive and toIndex, exclusive. Shifts any succeeding elements to the left (reduces their index). This call shortens the List by (toIndex - fromIndex) elements. (If toIndex==fromIndex, this operation has no effect.)

  Parameters:
    `fromIndex` - index of first element to be removed.
    `fromIndex` - index after last element to be removed.
  Throws:
    `java.lang.IndexOutOfBoundsException` - fromIndex or toIndex out of range (fromIndex < 0 || fromIndex >= size() || toIndex > size() || toIndex < fromIndex).

### addIfAbsent

    public boolean addIfAbsent(java.lang.Object element)

  Append the element if not present. This operation can be used to obtain Set semantics for lists.

  Parameters:
    `element` - element to be added to this Collection, if absent.
  Returns:
    true if added

### containsAll

    public boolean containsAll(java.util.Collection c)

  Returns true if this Collection contains all of the elements in the specified Collection.

  This implementation iterates over the specified Collection, checking each element returned by the Iterator in turn to see if it's contained in this Collection. If all elements are so contained true is returned, otherwise false.

### removeAll

    public boolean removeAll(java.util.Collection c)

  Removes from this Collection all of its elements that are contained in the specified Collection. This is a particularly expensive operation in this class because of the need for an internal temporary array.

  Returns:
    true if this Collection changed as a result of the call.

### retainAll

    public boolean retainAll(java.util.Collection c)

  Retains only the elements in this Collection that are contained in the specified Collection (optional operation). In other words, removes from this Collection all of its elements that are not contained in the specified Collection.

  Returns:
    true if this Collection changed as a result of the call.

### addAllAbsent

    public int addAllAbsent(java.util.Collection c)

  Appends all of the elements in the specified Collection that are not already contained in this list, to the end of this list, in the order that they are returned by the specified Collection's Iterator.

  Parameters:
    `c` - elements to be added into this list.
  Returns:
    the number of elements added

### clear

    public void clear()

  Removes all of the elements from this list.

  Specified by:
    `clear` in interface `java.util.Collection`
  Specified by:
    `clear` in interface `java.util.List`

### addAll

    public boolean addAll(java.util.Collection c)

  Appends all of the elements in the specified Collection to the end of this list, in the order that they are returned by the specified Collection's Iterator.

  Parameters:
    `c` - elements to be inserted into this list.

### addAll

    public boolean addAll(int index,
                          java.util.Collection c)

  Inserts all of the elements in the specified Collection into this list, starting at the specified position. Shifts the element currently at that position (if any) and any subsequent elements to the right (increases their indices). The new elements will appear in the list in the order that they are returned by the specified Collection's iterator.

  Parameters:
    `index` - index at which to insert first element from the specified collection.
    `c` - elements to be inserted into this list.
  Throws:
    `java.lang.IndexOutOfBoundsException` - index out of range (index < 0 || index > size()).

### rangeCheck

    protected void rangeCheck(int index,
                              int length)

  Check if the given index is in range. If not, throw an appropriate runtime exception.

### toString

    public java.lang.String toString()

  Returns a string representation of this Collection, containing the String representation of each element.

  Overrides:
    `toString` in class `java.lang.Object`

### equals

    public boolean equals(java.lang.Object o)

  Compares the specified Object with this List for equality. Returns true if and only if the specified Object is also a List, both Lists have the same size, and all corresponding pairs of elements in the two Lists are equal. (Two elements `e1` and `e2` are equal if `(e1==null ? e2==null : e1.equals(e2))`.) In other words, two Lists are defined to be equal if they contain the same elements in the same order.

  This implementation first checks if the specified object is this List. If so, it returns true; if not, it checks if the specified object is a List. If not, it returns false; if so, it iterates over both lists, comparing corresponding pairs of elements. If any comparison returns false, this method returns false. If either Iterator runs out of elements before before the other it returns false (as the Lists are of unequal length); otherwise it returns true when the iterations complete.

  Specified by:
    `equals` in interface `java.util.Collection`
  Specified by:
    `equals` in interface `java.util.List`
  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `o` - the Object to be compared for equality with this List.
  Returns:
    true if the specified Object is equal to this List.

### hashCode

    public int hashCode()

  Returns the hash code value for this List.

  This implementation uses exactly the code that is used to define the List hash function in the documentation for List.hashCode.

  Specified by:
    `hashCode` in interface `java.util.Collection`
  Specified by:
    `hashCode` in interface `java.util.List`
  Overrides:
    `hashCode` in class `java.lang.Object`

### iterator

    public java.util.Iterator iterator()

  Returns an Iterator over the elements contained in this collection. The iterator provides a snapshot of the state of the list when the iterator was constructed. No synchronization is needed while traversing the iterator. The iterator does NOT support the `remove` method.

  Specified by:
    `iterator` in interface `java.lang.Iterable`
  Specified by:
    `iterator` in interface `java.util.Collection`
  Specified by:
    `iterator` in interface `java.util.List`

### listIterator

    public java.util.ListIterator listIterator()

  Returns an Iterator of the elements in this List (in proper sequence). The iterator provides a snapshot of the state of the list when the iterator was constructed. No synchronization is needed while traversing the iterator. The iterator does NOT support the `remove`, `set`, or `add` methods.

  Specified by:
    `listIterator` in interface `java.util.List`

### listIterator

    public java.util.ListIterator listIterator(int index)

  Returns a ListIterator of the elements in this List (in proper sequence), starting at the specified position in the List. The specified index indicates the first element that would be returned by an initial call to nextElement. An initial call to previousElement would return the element with the specified index minus one. The ListIterator returned by this implementation will throw an UnsupportedOperationException in its remove, set and add methods.

  Specified by:
    `listIterator` in interface `java.util.List`
  Parameters:
    `index` - index of first element to be returned from the ListIterator (by a call to getNext).
  Throws:
    `java.lang.IndexOutOfBoundsException` - index is out of range (index < 0 || index > size()).

### subList

    public java.util.List subList(int fromIndex,
                                  int toIndex)

  Returns a view of the portion of this List between fromIndex, inclusive, and toIndex, exclusive. The returned List is backed by this List, so changes in the returned List are reflected in this List, and vice-versa. While mutative operations are supported, they are probably not very useful for CopyOnWriteArrays. The semantics of the List returned by this method become undefined if the backing list (i.e., this List) is structurally modified in any way other than via the returned List. (Structural modifications are those that change the size of the List, or otherwise perturb it in such a fashion that iterations in progress may yield incorrect results.)

  Specified by:
    `subList` in interface `java.util.List`
  Parameters:
    `fromIndex` - low endpoint (inclusive) of the subList.
    `toKey` - high endpoint (exclusive) of the subList.
  Returns:
    a view of the specified range within this List.
  Throws:
    `java.lang.IndexOutOfBoundsException` - Illegal endpoint index value (fromIndex < 0 || toIndex > size || fromIndex > toIndex).